#! /usr/bin/env python

import sys
from optparse import OptionParser
import random
import math


parser = OptionParser()
parser.add_option('-s', '--seed', help='the random seed',
                  default=0, action='store', type='int', dest='seed')
parser.add_option('-n', '--num_questions', help='number of questions',
                  default=5, action='store', type='int', dest='num_questions')
parser.add_option('-b', '--num_bits', help='number of bits in representation',
                  default=3, action='store', type='int', dest='num_bits')
parser.add_option('-c', help='compute answers for me', action='store_true',
                  default=False, dest='solve')

(options, args) = parser.parse_args()

seed = int(options.seed)
num_questions = int(options.num_questions)
num_bits = int(options.num_bits)
solve = options.solve

random.seed(options.seed)

print ''    
print 'Convert the numbers on the left into their binary 2s complement format.'
print 'Use different random seeds (-s <seed>) to get different problems.'
print 'Specify the number of questions with (-n <number>), and see if you'
print 'are right by having the program solve it for you (-c).'
print ''

pure_max = int(math.pow(2, num_bits - 1))
max_value = pure_max - 1
min_value = - max_value - 1
num_range = max_value - min_value + 1

asked = []

if num_questions > num_range:
    print 'Warning: Can only ask %d unique questions.' % (num_range)
    num_questions = num_range

while num_questions > 0:
    value = int(random.random() * num_range)
    if value in asked:
        continue
    asked.append(value)

    v = pure_max - value - 1
    if solve:
        if v < 0:
            print "input: ", v, '->', format((pure_max - abs(v)) + pure_max, '0%db' % num_bits)
        else:
            print "input:  ", v, '->', format(v, '0%db' % num_bits)
    else:
        if v < 0:
            print "input: ", v, '-> ?'
        else:
            print "input:  ", v, '-> ?'
    num_questions -= 1

